Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/FCTTRE.inc
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/FCTTRE.inc	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/FCTTRE.inc	(revision 633)
@@ -16,5 +16,6 @@
 !
       FOEEW ( PTARG,PDELARG ) = EXP ( &
-     &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-RTT) &
+!    &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-TEST_RTT) &
+     &          (R3LES*(1.-PDELARG)+R3IES*PDELARG) * (PTARG-273.16) &
      & / (PTARG-(R4LES*(1.-PDELARG)+R4IES*PDELARG)) )
 !
@@ -31,8 +32,10 @@
      &           + 25.21935 * EXP( - 2999.924 / ptarg))
 !
-      dqsats(ptarg,pqsarg) = RLVTT/RCPD*pqsarg * (3.56654/ptarg &
+!      dqsats(ptarg,pqsarg) = TEST_RLVTT/TEST_RCPD*pqsarg * (3.56654/ptarg &
+      dqsats(ptarg,pqsarg) = 0.2500800E+07/0.1004709E+04*pqsarg * (3.56654/ptarg &
      &                     +2484.896*LOG(10.)/ptarg**2 &
      &                     -0.00320991*LOG(10.))
-      dqsatl(ptarg,pqsarg) = RLVTT/RCPD*pqsarg*LOG(10.)* &
+!     dqsatl(ptarg,pqsarg) = TEST_RLVTT/TEST_RCPD*pqsarg*LOG(10.)* &
+      dqsatl(ptarg,pqsarg) = 0.2500800E+07/0.1004709E+04*pqsarg*LOG(10.)* &
      &                (2948.964/ptarg**2-5.028/LOG(10.)/ptarg &
      &                +25.21935*2999.924/ptarg**2*EXP(-2999.924/ptarg) &
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/albedo.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/albedo.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/albedo.F	(revision 633)
@@ -24,6 +24,6 @@
 ccc      PARAMETER (fmagic=0.7)
 cccIM => a remplacer  
-        PARAMETER (fmagic=1.32)
-c       PARAMETER (fmagic=1.0)
+c       PARAMETER (fmagic=1.32)
+        PARAMETER (fmagic=1.0)
 c       PARAMETER (fmagic=0.7)
       INTEGER npts ! il controle la precision de l'integration
@@ -147,6 +147,6 @@
 ccc      PARAMETER (fmagic=0.7)
 cccIM => a remplacer  
-        PARAMETER (fmagic=1.32)
-c       PARAMETER (fmagic=1.0)
+c       PARAMETER (fmagic=1.32)
+        PARAMETER (fmagic=1.0)
 c       PARAMETER (fmagic=0.7) 
 c
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calltherm.F
===================================================================
--- LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calltherm.F	(revision 633)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/calltherm.F	(revision 633)
@@ -0,0 +1,124 @@
+!
+! $Header$
+!
+      subroutine calltherm(dtime
+     s      ,pplay,paprs,pphi
+     s      ,u_seri,v_seri,t_seri,q_seri
+     s      ,d_u_ajs,d_v_ajs,d_t_ajs,d_q_ajs
+     s      ,fm_therm,entr_therm)
+
+      implicit none
+#include "dimensions.h"
+#include "dimphy.h"
+#include "thermcell.h"
+
+c  A inclure eventuellement dans les fichiers de configuration
+      data r_aspect_thermals,l_mix_thermals,tho_thermals/4.,10.,0./
+      data w2di_thermals/0/
+
+      REAL dtime
+
+      REAL u_seri(klon,klev),v_seri(klon,klev)
+      REAL t_seri(klon,klev),q_seri(klon,klev)
+      REAL paprs(klon,klev+1)
+      REAL pplay(klon,klev)
+      REAL pphi(klon,klev)
+
+CFH Update Thermiques
+      REAL d_t_ajs(klon,klev), d_q_ajs(klon,klev)
+      REAL d_u_ajs(klon,klev),d_v_ajs(klon,klev)
+      real fm_therm(klon,klev+1),entr_therm(klon,klev)
+
+
+c variables locales
+      REAL d_t_the(klon,klev), d_q_the(klon,klev)
+      REAL d_u_the(klon,klev),d_v_the(klon,klev)
+c
+      real zfm_therm(klon,klev+1),zentr_therm(klon,klev),zdt
+      save zentr_therm,zfm_therm
+
+      integer i,k
+
+*********************************************************
+
+c  Modele du thermique
+c  ===================
+c         print*,'thermiques: WARNING on passe t au lieu de t_seri'
+       print*,'avant isplit ',nsplit_thermals
+
+
+         fm_therm(:,:)=0.
+         entr_therm(:,:)=0.
+
+c   tests sur les valeurs negatives de l'eau
+         do k=1,klev
+            do i=1,klon
+               if (.not.q_seri(i,k).ge.0.) then
+                   print*,'WARN eau<0 avant therm i=',i,'  k=',k
+     s         ,' dq,q',d_q_the(i,k),q_seri(i,k)
+                  q_seri(i,k)=1.e-15
+               endif
+            enddo
+         enddo
+
+
+         zdt=dtime/float(nsplit_thermals)
+         do isplit=1,nsplit_thermals
+
+cym            CALL thermcell(klon,klev,zdt
+cym     s      ,pplay,paprs,pphi
+cym     s      ,u_seri,v_seri,t_seri,q_seri
+cym     s      ,d_u_the,d_v_the,d_t_the,d_q_the
+cym     s      ,zfm_therm,zentr_therm
+cym     s      ,r_aspect_thermals,l_mix_thermals,w2di_thermals
+cym     s      ,tho_thermals,3)
+
+            CALL thermcell(klon,klev,zdt
+     s      ,pplay,paprs,pphi
+     s      ,u_seri,v_seri,t_seri,q_seri
+     s      ,d_u_the,d_v_the,d_t_the,d_q_the
+     s      ,zfm_therm,zentr_therm
+     s      ,r_aspect_thermals,l_mix_thermals,w2di_thermals
+     s      ,tho_thermals)
+
+c  transformation de la derivee en tendance
+            d_t_the(:,:)=d_t_the(:,:)*dtime/float(nsplit_thermals)
+            d_u_the(:,:)=d_u_the(:,:)*dtime/float(nsplit_thermals)
+            d_v_the(:,:)=d_v_the(:,:)*dtime/float(nsplit_thermals)
+            d_q_the(:,:)=d_q_the(:,:)*dtime/float(nsplit_thermals)
+            fm_therm(:,:)=fm_therm(:,:)
+     s      +zfm_therm(:,:)/float(nsplit_thermals)
+            entr_therm(:,:)=entr_therm(:,:)
+     s       +zentr_therm(:,:)/float(nsplit_thermals)
+            fm_therm(:,klev+1)=0.
+
+
+
+c  accumulation de la tendance
+            d_t_ajs(:,:)=d_t_ajs(:,:)+d_t_the(:,:)
+            d_u_ajs(:,:)=d_u_ajs(:,:)+d_u_the(:,:)
+            d_v_ajs(:,:)=d_v_ajs(:,:)+d_v_the(:,:)
+            d_q_ajs(:,:)=d_q_ajs(:,:)+d_q_the(:,:)
+
+c  incrementation des variables meteo
+            t_seri(:,:) = t_seri(:,:) + d_t_the(:,:)
+            u_seri(:,:) = u_seri(:,:) + d_u_the(:,:)
+            v_seri(:,:) = v_seri(:,:) + d_v_the(:,:)
+            q_seri(:,:) = q_seri(:,:) + d_q_the(:,:)
+
+c   tests sur les valeurs negatives de l'eau
+            DO k = 1, klev
+            DO i = 1, klon
+               if (.not.q_seri(i,k).ge.0.) then
+                   print*,'WARN eau<0 apres therm i=',i,'  k=',k
+     s         ,' dq,q',d_q_the(i,k),q_seri(i,k)
+                  q_seri(i,k)=1.e-15
+               endif
+            ENDDO
+            ENDDO
+
+         enddo ! isplit
+
+      return
+
+      end
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clmain.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/clmain.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clmain.F	(revision 633)
@@ -17,6 +17,6 @@
      .                  d_t,d_q,d_u,d_v,d_ts,
      .                  flux_t,flux_q,flux_u,flux_v,cdragh,cdragm,
+     .                  q2,
      .                  dflux_t,dflux_q,
-cIM cf JLD    .                  zcoefh,zu1,zv1, t2m, q2m, u10m, v10m)
      .                  zcoefh,zu1,zv1, t2m, q2m, u10m, v10m,
      .                  fqcalving,ffonte, run_off_lic_0)
@@ -89,4 +89,5 @@
 #include "dimsoil.h"
 #include "iniprint.h"
+#include "compbl.h"
 c
       REAL dtime
@@ -183,10 +184,20 @@
 cAA      REAL yflxsrf(klon,nbtr)
 c
-      LOGICAL contreg
-      PARAMETER (contreg=.TRUE.)
 c
       LOGICAL ok_nonloc
       PARAMETER (ok_nonloc=.FALSE.)
       REAL ycoefm0(klon,klev), ycoefh0(klon,klev)
+
+      real yzlay(klon,klev),yzlev(klon,klev+1),yteta(klon,klev)
+      real ykmm(klon,klev+1),ykmn(klon,klev+1)
+      real ykmq(klon,klev+1)
+      real yq2(klon,klev+1),q2(klon,klev+1,nbsrf)
+      real q2diag(klon,klev+1)
+      real yustar(klon),y_cd_m(klon),y_cd_h(klon)
+
+
+
+
+
 c
 #include "YOMCST.h"
@@ -220,5 +231,5 @@
       LOGICAL first_appel
       SAVE first_appel
-      DATA first_appel/.false./
+      DATA first_appel/.true./
       LOGICAL debugindex
       SAVE debugindex
@@ -230,4 +241,9 @@
 c
       REAL yt2m(klon), yq2m(klon), yu10m(klon)
+c -- LOOP
+       REAL yu10mx(klon)
+       REAL yu10my(klon)
+       REAL ywindsp(klon)
+c -- LOOP
 c
       REAL uzon(klon), vmer(klon)
@@ -254,5 +270,5 @@
       endif
       IF (first_appel) THEN
-          first_appel=.false.
+!          first_appel=.false.
 !
 ! initialisation sorties netcdf
@@ -340,5 +356,9 @@
       ytsoil = 999999.
       yrugoro = 0.
-
+c -- LOOP
+      yu10mx = 0.0
+      yu10my = 0.0
+      ywindsp = 0.0
+c -- LOOP
       DO nsrf = 1, nbsrf
       DO i = 1, klon
@@ -447,4 +467,9 @@
         ypaprs(j,klev+1) = paprs(i,klev+1)
         y_run_off_lic_0(j) = run_off_lic_0(i)
+c -- LOOP
+       yu10mx(j) = u10m(i,nsrf)
+       yu10my(j) = v10m(i,nsrf)
+       ywindsp(j) = SQRT(yu10mx(j)*yu10mx(j) + yu10my(j)*yu10my(j) )
+c -- LOOP
       END DO
 C
@@ -479,5 +504,12 @@
 c
 c
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c calculer Cdrag et les coefficients d'echange
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c  Calcul anciens du LMD. Effectues de toutes facons.
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
       CALL coefkz(nsrf, knon, ypaprs, ypplay,
 cIM 261103
@@ -487,6 +519,25 @@
      .            yqsurf, 
      .            ycoefm, ycoefh)
+
       CALL coefkz2(nsrf, knon, ypaprs, ypplay,yt,
      .                  ycoefm0, ycoefh0)
+      if (first_appel) then
+        if (prt_level > 9) THEN
+          WRITE(lunout,*)'Apres coefkz2 '
+          WRITE(lunout,*)'nsrf,knon,yts,yrugos,yqsurf',
+     .    nsrf,knon,yts,yrugos,yqsurf
+          WRITE(lunout,*)'ypaprs(1,k),ypplay(1,k),yu,yv,yt'
+          do k=1,klev
+            WRITE(lunout,*)ypaprs(1,k),ypplay(1,k),
+     .      yu(1,k),yv(1,k),yt(1,k)
+          enddo
+          do k=1,klev
+            WRITE(lunout,*)ycoefm(1,k),ycoefh(1,k),
+     .      ycoefm0(1,k),ycoefh0(1,k)
+          enddo
+        ENDIF
+        first_appel=.false.
+      endif
+
       DO k = 1, klev
       DO i = 1, knon
@@ -495,4 +546,5 @@
       ENDDO
       ENDDO
+
 c
 cIM cf JLD : on seuille ycoefm et ycoefh
@@ -528,6 +580,78 @@
 cIM: 261103
 
-c
+
+      IF (iflag_pbl.ge.3) then
+
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+c MELLOR ET YAMADA adapte a Mars Richard Fournier et Frederic Hourdin
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
+         yzlay(1:knon,1)=
+     .   RD*yt(1:knon,1)/(0.5*(ypaprs(1:knon,1)+ypplay(1:knon,1)))
+     .   *(ypaprs(1:knon,1)-ypplay(1:knon,1))/RG
+         do k=2,klev
+            yzlay(1:knon,k)=
+     .      yzlay(1:knon,k-1)+RD*0.5*(yt(1:knon,k-1)+yt(1:knon,k))
+     .      /ypaprs(1:knon,k)*(ypplay(1:knon,k-1)-ypplay(1:knon,k))/RG
+         enddo
+         do k=1,klev
+            yteta(1:knon,k)=
+     .      yt(1:knon,k)*(ypaprs(1:knon,1)/ypplay(1:knon,k))**rkappa
+     .      *(1.+0.61*yq(1:knon,k))
+         enddo
+         yzlev(1:knon,1)=0.
+         yzlev(1:knon,klev+1)=2.*yzlay(1:knon,klev)-yzlay(1:knon,klev-1)
+         do k=2,klev
+            yzlev(1:knon,k)=0.5*(yzlay(1:knon,k)+yzlay(1:knon,k-1))
+         enddo
+         DO k = 1, klev+1
+            DO j = 1, knon
+               i = ni(j)
+               yq2(j,k)=q2(i,k,nsrf)
+            enddo
+         enddo
+
+
+c   Bug introduit volontairement pour converger avec les resultats
+c  du papier sur les thermiques.
+         if (1.eq.1) then
+         y_cd_m(1:knon) = ycoefm(1:knon,1)
+         y_cd_h(1:knon) = ycoefh(1:knon,1)
+         else
+         y_cd_h(1:knon) = ycoefm(1:knon,1)
+         y_cd_m(1:knon) = ycoefh(1:knon,1)
+         endif
+         call ustarhb(knon,yu,yv,y_cd_m, yustar)
+
+        if (prt_level > 9) THEN
+          WRITE(lunout,*)'USTAR = ',yustar
+        ENDIF
+
+c   iflag_pbl peut etre utilise comme longuer de melange
+
+         if (iflag_pbl.ge.11) then
+            call vdif_kcay(knon,dtime,rg,rd,ypaprs,yt
+     s      ,yzlev,yzlay,yu,yv,yteta
+     s      ,y_cd_m,yq2,q2diag,ykmm,ykmn,yustar,
+     s      iflag_pbl)
+         else
+            call yamada4(knon,dtime,rg,rd,ypaprs,yt
+     s      ,yzlev,yzlay,yu,yv,yteta
+     s      ,y_cd_m,yq2,ykmm,ykmn,ykmq,yustar,
+     s      iflag_pbl)
+         endif
+
+         ycoefm(1:knon,1)=y_cd_m(1:knon)
+         ycoefh(1:knon,1)=y_cd_h(1:knon)
+         ycoefm(1:knon,2:klev)=ykmm(1:knon,2:klev)
+         ycoefh(1:knon,2:klev)=ykmn(1:knon,2:klev)
+
+
+      ENDIF
+
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c calculer la diffusion des vitesses "u" et "v"
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
+
       CALL clvent(knon,dtime,yu1,yv1,ycoefm,yt,yu,ypaprs,ypplay,ydelp,
      s            y_d_u,y_flux_u)
@@ -545,5 +669,7 @@
 c$$$      enddo
 
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
 c calculer la diffusion de "q" et de "h"
+cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
       CALL clqh(dtime, itap, date0,jour, debut,lafin,
      e          rlon, rlat, cufi, cvfi,
@@ -555,10 +681,12 @@
      e          yt,yq,yts,ypaprs,ypplay,
      e          ydelp,yrads,yalb, yalblw, ysnow, yqsurf, 
-     e          yrain_f, ysnow_f, yfder, ytaux, ytauy, 
+     e          yrain_f, ysnow_f, yfder, ytaux, ytauy,
+c -- LOOP
+     e          ywindsp, 
+c -- LOOP
 c$$$     e          ysollw, ysolsw,
      e          ysollw, ysollwdown, ysolsw,yfluxlat,
      s          pctsrf_new, yagesno,
      s          y_d_t, y_d_q, y_d_ts, yz0_new,
-cIM cf JLD    s          y_flux_t, y_flux_q, y_dflux_t, y_dflux_q)
      s          y_flux_t, y_flux_q, y_dflux_t, y_dflux_q,
      s          y_fqcalving,y_ffonte,y_run_off_lic_0)
@@ -699,23 +827,4 @@
 c
         qairsol(j) = yqsurf(j)
-c$$$        IF (nsrf.EQ.1) THEN
-c$$$          qairsol(j) = yqsurf(j)
-c$$$        ELSE IF(nsrf.GT.1) THEN
-c$$$         zt = ts(i,nsrf)
-c$$$         IF (thermcep) THEN
-c$$$           zdelta = MAX(0.,SIGN(1.,RTT-zt))
-c$$$           zqs = R2ES * FOEEW(zt,zdelta) / ypplay(j,1)
-c$$$           zqs = MIN(0.5,zqs)
-c$$$           zcor = 1./(1.-RETV*zqs)
-c$$$           zqs = zqs*zcor
-c$$$         ELSE
-c$$$           IF (zt .LT. t_coup) THEN
-c$$$             zqs = qsats(zt) / ypplay(j,1)
-c$$$           ELSE
-c$$$             zqs = qsatl(zt) / ypplay(j,1)
-c$$$           ENDIF
-c$$$         ENDIF   
-c$$$         qairsol(j) = zqs
-c$$$        ENDIF   
       ENDDO
 c
@@ -778,4 +887,13 @@
        ENDDO 
 #endif
+
+      do j=1,knon
+         do k=1,klev+1
+         i=ni(j)
+         q2(i,k,nsrf)=yq2(j,k)
+         enddo
+      enddo
+c
+
 99999 CONTINUE
 c
@@ -799,8 +917,10 @@
      e                delp,radsol,albedo,alblw,snow,qsurf, 
      e                precip_rain, precip_snow, fder, taux, tauy,
+c -- LOOP
+     e                ywindsp,
+c -- LOOP
      $                sollw, sollwdown, swnet,fluxlat, 
      s                pctsrf_new, agesno,
      s                d_t, d_q, d_ts, z0_new, 
-cIM cf JLD    s                flux_t, flux_q,dflux_s,dflux_l)
      s                flux_t, flux_q,dflux_s,dflux_l,
      s                fqcalving,ffonte,run_off_lic_0)
@@ -820,4 +940,5 @@
 #include "indicesol.h"
 #include "dimsoil.h"
+#include "iniprint.h"
 
 c Arguments:
@@ -857,4 +978,10 @@
       character*6 ocean
       integer npas, nexca
+c -- LOOP
+       REAL yu10mx(klon)
+       REAL yu10my(klon)
+       REAL ywindsp(klon)
+c -- LOOP
+
 
 c
@@ -901,6 +1028,5 @@
       REAL zdelz
 c======================================================================
-      logical contreg
-      parameter (contreg=.true.)
+#include "compbl.h"
 c======================================================================
 c Rajout pour l'interface
@@ -944,12 +1070,6 @@
       ENDIF
 C
-      if (.not. contreg) then
-        do k = 2, klev
-          do i = 1, knon
-            gamq(i,k) = 0.0
-            gamt(i,k) = 0.0
-          enddo
-        enddo
-      else
+C
+      if (iflag_pbl.eq.1) then
         do k = 3, klev
           do i = 1, knon
@@ -961,4 +1081,11 @@
           gamq(i,2) = 0.0
           gamt(i,2) = -2.5e-03
+        enddo
+      else
+        do k = 2, klev
+          do i = 1, knon
+            gamq(i,k) = 0.0
+            gamt(i,k) = 0.0
+          enddo
         enddo
       endif
@@ -1083,5 +1210,9 @@
      e tq_cdrag, petAcoef, peqAcoef, petBcoef, peqBcoef,
      e precip_rain, precip_snow, sollw, sollwdown, swnet, swdown,
-     e fder, taux, tauy, rugos, rugoro,
+     e fder, taux, tauy, 
+c -- LOOP
+     e ywindsp,
+c -- LOOP
+     e rugos, rugoro,
      e albedo, snow, qsurf,
      e ts, p1lay, psref, radsol,
@@ -1089,5 +1220,4 @@
      s evap, fluxsens, fluxlat, dflux_l, dflux_s,              
      s tsol_rad, tsurf_new, alb_new, alblw, emis_new, z0_new, 
-cIM cf JLD    s pctsrf_new, agesno)
      s pctsrf_new, agesno,fqcalving,ffonte, run_off_lic_0)
 
@@ -1162,4 +1292,5 @@
 #include "dimensions.h"
 #include "dimphy.h"
+#include "iniprint.h"
       INTEGER knon
       REAL dtime
@@ -1288,4 +1419,5 @@
 #include "YOMCST.h"
 #include "indicesol.h"
+#include "iniprint.h"
 c
 c Arguments:
@@ -1335,6 +1467,6 @@
       LOGICAL opt_ec ! formule du Centre Europeen dans l'atmosphere
       PARAMETER (opt_ec=.FALSE.)
-      LOGICAL contreg ! utiliser le contre-gradient dans Ri
-      PARAMETER (contreg=.TRUE.)
+
+#include "compbl.h"
 c
 c Variables locales:
@@ -1379,10 +1511,12 @@
 c
       IF (appel1er) THEN
-         PRINT*, 'coefkz, opt_ec:', opt_ec
-         PRINT*, 'coefkz, richum:', richum
-         IF (richum) PRINT*, 'coefkz, ratqs:', ratqs
-         PRINT*, 'coefkz, isommet:', isommet
-         PRINT*, 'coefkz, tvirtu:', tvirtu
-         appel1er = .FALSE.
+        if (prt_level > 9) THEN
+          WRITE(lunout,*)'coefkz, opt_ec:', opt_ec
+          WRITE(lunout,*)'coefkz, richum:', richum
+          IF (richum) WRITE(lunout,*)'coefkz, ratqs:', ratqs
+          WRITE(lunout,*)'coefkz, isommet:', isommet
+          WRITE(lunout,*)'coefkz, tvirtu:', tvirtu
+          appel1er = .FALSE.
+        endif
       ENDIF
 c
@@ -1399,22 +1533,16 @@
       ENDDO
 
-c$$$      IF(nsrf.NE.1) THEN
-c$$$      do i = 1, knon
-c$$$        qsurf(i) = qsatl(ts(i))/paprs(i,1)
-c$$$      enddo
-c$$$      ENDIF
-
 c
 c Prescrire la valeur de contre-gradient
 c
-      IF (.NOT.contreg) THEN
-         DO k = 2, klev
-            gamt(k) = 0.0
-         ENDDO
-      ELSE
+      if (iflag_pbl.eq.1) then
          DO k = 3, klev
             gamt(k) = -1.0E-03
          ENDDO
          gamt(2) = -2.5E-03
+      else
+         DO k = 2, klev
+            gamt(k) = 0.0
+         ENDDO
       ENDIF
 cIM cf JLD/ GKtest
@@ -1469,7 +1597,4 @@
       ENDDO
 
-      IF (check) THEN
-      PRINT*,' isommet=',isommet,' knon=',knon
-      ENDIF
 
       DO k = 2, isommet
@@ -1608,4 +1733,5 @@
 #include "YOMCST.h"
 #include "indicesol.h"
+#include "iniprint.h"
 c
 c Arguments:
@@ -1702,4 +1828,5 @@
 #include "YOMCST.h"
 #include "indicesol.h"
+#include "iniprint.h"
       REAL tau_gl ! temps de relaxation pour la glace de mer
 ccc      PARAMETER (tau_gl=86400.0*30.0)
@@ -1783,4 +1910,5 @@
 #include "dimphy.h"
 #include "YOMCST.h"
+#include "iniprint.h"
 c
 c Arguments:
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clouds_gno.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/clouds_gno.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/clouds_gno.F	(revision 633)
@@ -58,5 +58,7 @@
        LOGICAL lconv(klon)
 
-
+cym
+      cldf(:,:)=0.0
+      
       pi = ACOS(-1.)
       sqrtpi=sqrt(pi)
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/comgeomphy.F90
===================================================================
--- LMDZ4/branches/LMDZ4_par_0/libf/phylmd/comgeomphy.F90	(revision 633)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/comgeomphy.F90	(revision 633)
@@ -0,0 +1,20 @@
+module comgeomphy
+   real,save,allocatable :: airephy(:)
+   real,save,allocatable :: cuphy(:)
+   real,save,allocatable :: cvphy(:)
+   real,save,allocatable :: rlatd(:)
+   real,save,allocatable :: rlond(:)
+contains
+  
+  subroutine InitComgeomphy
+  use dimphy
+  implicit none
+    
+    allocate(airephy(klon))
+    allocate(cuphy(klon))
+    allocate(cvphy(klon))
+    allocate(rlatd(klon))
+    allocate(rlond(klon))
+  end subroutine InitComgeomphy
+  
+end module comgeomphy
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/compbl.h
===================================================================
--- LMDZ4/branches/LMDZ4_par_0/libf/phylmd/compbl.h	(revision 633)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/compbl.h	(revision 633)
@@ -0,0 +1,2 @@
+      integer iflag_pbl
+      common/compbl/iflag_pbl
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/concvl.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/concvl.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/concvl.F	(revision 633)
@@ -7,5 +7,7 @@
      .             upwd,dnwd,dnwdbis,Ma,cape,tvp,iflag,
      .             pbase,bbase,dtvpdt1,dtvpdq1,dplcldt,dplcldr,
-     .             qcondc,wd)
+     .             qcondc,wd,
+     .             pmflxr,pmflxs,
+     .             da,phi,mp)
  
 c
@@ -56,4 +58,5 @@
        INTEGER ntra
        REAL work1(klon,klev),work2(klon,klev)
+       REAL pmflxr(klon,klev+1),pmflxs(klon,klev+1)
 c
        REAL d_t(klon,klev),d_q(klon,klev),d_u(klon,klev),d_v(klon,klev)
@@ -65,4 +68,5 @@
        REAL upwd(klon,klev),dnwd(klon,klev),dnwdbis(klon,klev)
        REAL Ma(klon,klev),cape(klon),tvp(klon,klev)
+       real da(klon,klev),phi(klon,klev,klev),mp(klon,klev)
        INTEGER iflag(klon)
        REAL rflag(klon)
@@ -88,4 +92,7 @@
 c
 c
+cym
+      snow(:)=0
+      
       IF (ifrst .EQ. 0) THEN
          ifrst = 1
@@ -98,4 +105,5 @@
          DO i=1,klon
          em_ph(i,k) = paprs(i,k) / 100.0
+         pmflxs(i,k)=0.
       ENDDO
       ENDDO
@@ -142,6 +150,8 @@
      $              em_p,em_ph,iflag,
      $              d_t,d_q,d_u,d_v,d_tra,rain,
-     $              cbmf,work1,work2,
-     $              dtime,Ma,upwd,dnwd,dnwdbis,qcondc,wd,cape)
+     $              pmflxr,cbmf,work1,work2,
+     $              kbas,ktop,
+     $              dtime,Ma,upwd,dnwd,dnwdbis,qcondc,wd,cape,
+     $              da,phi,mp)
 
 C------------------------------------------------------------------
@@ -160,5 +170,11 @@
         ENDDO
       ENDDO
- 
+       DO itra = 1,ntra
+        DO k = 1, klev
+         DO i = 1, klon
+            d_tra(i,k,itra) =dtime*d_tra(i,k,itra) 
+         ENDDO
+        ENDDO
+       ENDDO
 c les traceurs ne sont pas mis dans cette version de convect4:
       if (iflag_con.eq.4) then
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conf_phys.F90
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/conf_phys.F90	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/conf_phys.F90	(revision 633)
@@ -9,5 +9,6 @@
  &                     ratqsbas,ratqshaut,if_ebil, &
  &		       ok_ade, ok_aie, &
- &                     bl95_b0, bl95_b1)
+ &                     bl95_b0, bl95_b1,&
+ &                     iflag_thermals,nsplit_thermals)
 
    use IOIPSL
@@ -19,5 +20,6 @@
 #include "YOMCST.inc"
 !IM : on inclut/initialise les taux de CH4, N2O, CFC11 et CFC12
-#include "clesphys.inc"
+include "clesphys.inc"
+include "compbl.h"
 !
 ! Configuration de la "physique" de LMDZ a l'aide de la fonction
@@ -51,4 +53,5 @@
   real                 :: zzz
 
+  integer :: iflag_thermals,nsplit_thermals
 !
 !
@@ -514,4 +517,35 @@
   ok_kzmin = .true.
   call getin('ok_kzmin',ok_kzmin)
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+! PARAMETER FOR THE PLANETARY BOUNDARY LAYER
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+!Config Key  = iflag_pbl
+!Config Desc =
+!Config Def  = 1
+!Config Help =
+!
+  iflag_pbl = 1
+  call getin('iflag_pbl',iflag_pbl)
+!
+!Config Key  = iflag_thermals
+!Config Desc =
+!Config Def  = 0
+!Config Help =
+!
+  iflag_thermals = 0
+  call getin('iflag_thermals',iflag_thermals)
+!
+!
+!Config Key  = nsplit_thermals
+!Config Desc =
+!Config Def  = 1
+!Config Help =
+!
+  nsplit_thermals = 1
+  call getin('nsplit_thermals',nsplit_thermals)
+
+
 
 !
@@ -606,4 +640,6 @@
   write(numout,*)' lev_histday = ',lev_histday 
   write(numout,*)' lev_histmth = ',lev_histmth 
+  write(numout,*)' iflag_pbl = ', iflag_pbl
+  write(numout,*)' iflag_thermals = ', iflag_thermals
 
   return
@@ -634,5 +670,5 @@
 !Config Help = 
 !
-  tau_calv = 360.
+  tau_calv = 360.*10.
   call getin('tau_calv',tau_calv)
 
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cv3_routines.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/cv3_routines.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/cv3_routines.F	(revision 633)
@@ -194,5 +194,6 @@
       real pnk(len), qsnk(len), rh(len), chi(len)
       real A, B ! convect3
-
+cym
+      plcl=0.0
 c@ !-------------------------------------------------------------------
 c@ ! --- Find level of minimum moist static energy
@@ -1194,6 +1195,12 @@
 c=====================================================================
 c
-      do i=1,ncum*nlp
-       hp(i,1)=h(i,1)
+cym      do i=1,ncum*nlp
+cym       hp(i,1)=h(i,1)
+cym      enddo
+
+      do k=1,nlp
+        do i=1,ncum
+	  hp(i,k)=h(i,k)
+	enddo
       enddo
 
@@ -1488,10 +1495,14 @@
             vent(i,k,j)=v(i,j)
             elij(i,k,j)=0.0
-            ment(i,k,j)=0.0
-            sij(i,k,j)=0.0
+cym            ment(i,k,j)=0.0
+cym            sij(i,k,j)=0.0
  385      continue
  390    continue
  400  continue
 
+cym
+      ment(1:ncum,1:nd,1:nd)=0.0
+      sij(1:ncum,1:nd,1:nd)=0.0
+      
 c      do k=1,ntra
 c       do j=1,nd  ! instead nlp
@@ -1620,7 +1631,10 @@
 c=====================================================================
 
-      call zilch(asum,ncum*nd)
-      call zilch(bsum,ncum*nd)
-      call zilch(csum,ncum*nd)
+cym      call zilch(asum,ncum*nd)
+cym      call zilch(bsum,ncum*nd)
+cym      call zilch(csum,ncum*nd)
+      call zilch(asum,nloc*nd)
+      call zilch(csum,nloc*nd)
+      call zilch(csum,nloc*nd)
 
       do il=1,ncum
@@ -2150,5 +2164,5 @@
      :                    ,ment,qent,uent,vent,nent,elij,traent,sig
      :                    ,tv,tvp
-     :                    ,iflag,precip,ft,fr,fu,fv,ftra
+     :                    ,iflag,precip,VPrecip,ft,fr,fu,fv,ftra
      :                    ,upwd,dnwd,dnwd0,ma,mike,tls,tps,qcondc,wd)
       implicit none
@@ -2172,5 +2186,7 @@
       real water(nloc,na), evap(nloc,na), b(nloc,na)
       real ment(nloc,na,na), qent(nloc,na,na), uent(nloc,na,na)
-      real vent(nloc,na,na), nent(nloc,na), elij(nloc,na,na)
+cym      real vent(nloc,na,na), nent(nloc,na), elij(nloc,na,na)
+      real vent(nloc,na,na), elij(nloc,na,na)
+      integer nent(nloc,na)
       real traent(nloc,na,na,ntra)
       real tv(nloc,nd), tvp(nloc,nd)
@@ -2181,4 +2197,5 @@
 c outputs:
       real precip(nloc)
+      real VPrecip(nloc,nd+1)
       real ft(nloc,nd), fr(nloc,nd), fu(nloc,nd), fv(nloc,nd)
       real ftra(nloc,nd,ntra)
@@ -2212,8 +2229,10 @@
        precip(il)=0.0
        wd(il)=0.0     ! gust
+       VPrecip(il,nd+1)=0.
       enddo
 
       do i=1,nd
        do il=1,ncum
+         VPrecip(il,i)=0.0
          ft(il,i)=0.0
          fr(il,i)=0.0
@@ -2254,4 +2273,19 @@
       enddo 
 
+C   ***  CALCULATE VERTICAL PROFILE OF  PRECIPITATIONs IN kg/m2/s  ===
+C
+c MAF rajout pour lessivage
+       do k=1,nl
+         do il=1,ncum
+          if (k.le.inb(il)) then
+            if (cvflag_grav) then
+             VPrecip(il,k) = wt(il,k)*sigd*water(il,k)/grav
+            else
+             VPrecip(il,k) = wt(il,k)*sigd*water(il,k)/10.
+            endif 
+          endif
+         end do
+       end do
+C
 c
 c   ***  Calculate downdraft velocity scale    ***
@@ -3009,12 +3043,15 @@
       SUBROUTINE cv3_uncompress(nloc,len,ncum,nd,ntra,idcum
      :         ,iflag
-     :         ,precip,sig,w0
+     :         ,precip,VPrecip,sig,w0
      :         ,ft,fq,fu,fv,ftra
+     :         ,inb
      :         ,Ma,upwd,dnwd,dnwd0,qcondc,wd,cape
+     :         ,da,phi,mp
      :         ,iflag1
-     :         ,precip1,sig1,w01
+     :         ,precip1,VPrecip1,sig1,w01
      :         ,ft1,fq1,fu1,fv1,ftra1
+     :         ,inb1
      :         ,Ma1,upwd1,dnwd1,dnwd01,qcondc1,wd1,cape1
-     :                               )
+     :         ,da1,phi1,mp1)
       implicit none
 
@@ -3025,5 +3062,7 @@
       integer idcum(nloc)
       integer iflag(nloc)
+      integer inb(nloc)
       real precip(nloc)
+      real VPrecip(nloc,nd+1)
       real sig(nloc,nd), w0(nloc,nd)
       real ft(nloc,nd), fq(nloc,nd), fu(nloc,nd), fv(nloc,nd)
@@ -3033,8 +3072,11 @@
       real qcondc(nloc,nd)
       real wd(nloc),cape(nloc)
+      real da(nloc,nd),phi(nloc,nd,nd),mp(nloc,nd)
 
 c outputs:
       integer iflag1(len)
+      integer inb1(len)
       real precip1(len)
+      real VPrecip1(len,nd+1)
       real sig1(len,nd), w01(len,nd)
       real ft1(len,nd), fq1(len,nd), fu1(len,nd), fv1(len,nd)
@@ -3044,4 +3086,5 @@
       real qcondc1(nloc,nd)
       real wd1(nloc),cape1(nloc)
+      real da1(nloc,nd),phi1(nloc,nd,nd),mp1(nloc,nd)
 
 c local variables:
@@ -3052,4 +3095,5 @@
          iflag1(idcum(i))=iflag(i)
          wd1(idcum(i))=wd(i)
+         inb1(idcum(i))=inb(i)
          cape1(idcum(i))=cape(i)
  2000   continue
@@ -3057,4 +3101,5 @@
         do 2020 k=1,nl
           do 2010 i=1,ncum
+            VPrecip1(idcum(i),k)=VPrecip(i,k)
             sig1(idcum(i),k)=sig(i,k)
             w01(idcum(i),k)=w0(i,k)
@@ -3068,4 +3113,6 @@
             dnwd01(idcum(i),k)=dnwd0(i,k)
             qcondc1(idcum(i),k)=qcondc(i,k)
+            da1(idcum(i),k)=da(i,k)
+            mp1(idcum(i),k)=mp(i,k)
  2010     continue
  2020   continue
@@ -3083,4 +3130,11 @@
 c 2110    continue
 c 2100   continue
+        do j=1,nd
+         do k=1,nd 
+          do i=1,ncum
+            phi1(idcum(i),k,j)=phi(i,k,j)
+          end do
+         end do
+        end do
 
         return
